; MDRV98 Player
; C[` (for NASM)

%include 'hoot.inc'

		ORG	0x0100
		USE16
		CPU	186

start:		cli
		mov	ax,cs
		mov	ds,ax
		mov	es,ax
		mov	sp,stack	; [JX^bNݒ

		mov	bx,prgend
		add	bx,0x0f
		shr	bx,4
		mov	ah,0x4a		; [DOS] ubN̏k(ES:BX)
		int	0x21

		mov	ah,0x48		; [DOS] [hobt@̊蓖
		mov	bx,0x4000	; pOtTCY(256K)
		int	0x21
		mov	[loadseg],ax

		mov	ax,0x257f	; hoothCoo^
		mov	dx,vect_7f
		int	0x21

		sti
mainloop:	mov	ax,0x9801		; _~[|[O
		int	0x18
		jmp	short mainloop

; hootR[
; inp8(HOOTPORT) = 0  PC98DOS::Play
; inp8(HOOTPORT) = 2  PC98DOS::Stop
; _code = inp8(HOOTPORT+2)`inp8(HOOTPORT+5)

vect_7f:	pusha
		push	ds
		push	es
		mov	ax,cs
		mov	ds,ax
		mov	es,ax
		mov	dx,HOOTPORT
		in	al,dx
		cmp	al,HP_PLAY
		jz	short .play
		cmp	al,HP_STOP
		jz	short .fadeout
.ed:		pop	es
		pop	ds
		popa
		iret

.play:		mov	ah,0x03		; t~
		int	0xf2

		mov	ds,[loadseg]
		xor	dx,dx
		xor	bx,bx		; W
		mov	cx,0xffff	; f[^TCY
		mov	ah,0x3f		; [DOS] read hundle
		int	0x21
		jc	.stop

		mov	si,dx		; ȃf[^Zbg(DS:SI)
		mov	ah,0x06
		int	0xf2

		mov	dx,HOOTPORT+4	; PCMw̗L̎擾
		in	al,dx
		mov	bl,al
		xor	bh,bh
		call	getpcmname	; ADPCMt@C擾
		call	pcm_check	; YPCM[hς݂ǂׂ
		jnc	.play_start	; [hς݂̏ꍇ͉tJn

		call	make_pcmname	; PCMt@C
		mov	dx,tabname
		call	file_load	; TABt@C[h
		jc	.play_start	; [hsPCMȂ

		mov	ah,0x08		; PCMe[uf[^MDRV98֓] (DS:SI)
		int	0xf2

		mov	ax,cs
		mov	ds,ax
		mov	dx,pcmname
		call	file_load	; PCMt@C[h
		jc	.play_start	; [hɎsꍇPCMȂ

		mov	bx,0x0010/4	; OPNA ADPCMAhX
;		mov	ah,0x16		; PCMf[^ADPCMփ[h (DS:SI TCY: CX)
;		int	0xf2		; (TCY:CX)
; MDRV98 3.4FINT F2 AH=15,16̃T[rXt@NVɂ̓oOA
; t@NVĂяoɓK؂DS=CS̏ɃANZXĂāA
; ۂɎgpƖ\邽߁Aփ[`gp
; t@NV̎dl65535oCgȏ̃TCYPCM]łȂ߁AgɂȂȂ
		call	adpcm_write	; ADPCMf[^(DS:SI TCY=AX:CX)
		mov	byte [cs:pcm_loaded],0xff	; PCM[hς݃tOZbg

.play_start:	xor	ah,ah		; tJn
		int	0xf2
		jmp	short .ed

.stop:		mov	ah,0x03		; t~
		int	0xf2
		jmp	short .ed

.fadeout:	mov	ah,0x02		; tF[hAEg
		int	0xf2
		jmp	short .ed


; PCMt@C̎擾
;   in: BX=t@Cnh
;  out: DS:SI=PCMt@Ĉʒu
getpcmname:	or	bx,bx		; 0x0000 w肳ꂽƂ͋ȃf[^T
		jz	.skip1

		mov	ax,cs
		mov	ds,ax
		xor	cx,cx		; t@C|C^擪ɖ߂
		mov	dx,cx
		mov	ax,0x4200	; V[N
		int	0x21
		mov	ah,0x3f
		mov	dx,dsgname	; ADPCM[hobt@
		mov	cx,8		; ő8
		int	0x21		; w肳ꂽADPCMt@C̃[h
		jc	.skip1
		mov	si,dx		; [h̓[ht@C̈ʒuԂ
		ret

.skip1:		mov	ds,[cs:loadseg]
		mov	si,0x0040	; ȃf[^PCMt@CItZbgԂ
		ret


; PCM[hς݂ǂ𒲂ׂ
;  in: DS:SI=PCMt@Ĉʒu
; out: CY=0 : w肳ꂽPCM̓[hς
;      CY=1 : w肳ꂽPCM̓[hĂȂ
pcm_check:	cld
		push	es
		push	si
		cmp	byte [cs:pcm_loaded],0x00	; [hσtO`FbN
		jz	.exit		; [hĂȂꍇ͔
		mov	ax,cs
		mov	es,ax
		mov	di,pcmname	; [hςPCMt@CƔr
		mov	cx,8		; ő8
.pnloop:	lodsb
		or	al,al		; I[`FbN
		jz	.next
		cmp	al,[es:di]	; r
		jnz	.not_loaded
		inc	di
		loop	.pnloop

.next:		pop	si
		pop	es		; [hς݂ł
		clc
		ret

.not_loaded:	mov	byte [cs:pcm_loaded],0x00	; [hς݃tONA
.exit:		pop	si
		pop	es		; [hĂ܂
		stc
		ret


; PCM/TAB̃t@C
;   in : DS:SI = gqȂPCMt@ĈAhX
;  out : DS    = gqtPCMt@C쐬ZOg(=CS)
make_pcmname:	cld
		mov	di,pcmname	; t@Ci[
		mov	cx,8		; ő8
.pnloop:	lodsb
		or	al,al		; I[?
		jz	.next		; I[̏ꍇ͔
		mov	[cs:di],al	; t@Ci[
		mov	[cs:di+13],al
		inc	di
		loop	.pnloop		; [v
.next:		mov	si,pcmext	; gqA
		mov	cx,5		; 5
.extloop:	mov	al,[cs:si]
		mov	ah,[cs:si+5]
		inc	si
		mov	[cs:di],al
		mov	[cs:di+13],ah
		inc	di
		loop	.extloop
		push	cs
		pop	ds		; DS=CSŖ߂
		ret


; [hobt@Ƀt@C[h
;   in : DS:DX = [hΏۃt@C
;  out : DS:SI = ǂݍ񂾃AhX
;        CY = 0 : I
;        CY = 1 : ُI
;        AX:CX = ǂݍ񂾃TCY (CYɂȂ)
file_load:	mov	ax,0x3d00	; t@CI[v
		int	0x21
		jc	.loaderr
		mov	bx,ax		; t@Cnhۑ
		mov	ds,[cs:loadseg]
		xor	dx,dx		; obt@擪

.load_loop:	mov	cx,0xfff0	; xɓǂލől
		mov	ah,0x3f		; t@C[h
		int	0x21
		mov	cx,ax		; ۂɓǂ񂾃TCYCXɕԂ
		jc	.loaderr
		jcxz	.load_end	; ǂݍ񂾃oCg0oCgȂI
		cmp	cx,ax
		jnz	.load_end	; ǂݍ݃TCYƈقȂI

		add	dx,ax		; ɓǂݍރAhXύX
		cmp	dx,0x8000
		jc	.load_loop
		call	adj_seg		; ItZbg0x8000𒴂ZOgK
		jmp	short .load_loop

.load_end:	mov	ah,0x03e	; t@CN[Y
		int	0x21

		call	adj_seg		; AhX𐳋K
		mov	ax,ds
		mov	bx,[cs:loadseg]
		mov	ds,bx		; Ԃǂݍ݈ʒu(DS:SI)
		xor	si,si
		sub	ax,bx		; ZOg߂
		mov	bx,ax
		shr	bx,12		; ǂݍ񂾃TCY4bitvZ
		shl	ax,4		; ǂݍ񂾃TCY16bitvZ
		add	dx,ax		; ItZbgɉZ
		mov	cx,dx		; t@CTCY̌vZʂ AX:CX ɓ
		mov	ax,bx
		clc
.loaderr:	ret


; ZOgK (ItZbgŏɂȂ悤ɒ)
;   in: DS:DX
;  out: DS:DX
adj_seg:	push	ax
		push	bx
		mov	ax,ds
		mov	bx,dx
		shr	bx,4		; ItZbg/16
		add	ax,bx		; ZOgɉZ
		mov	ds,ax
		and	dx,0x000f	; ItZbg4bit݂̂ɂ
		pop	bx
		pop	ax
		ret


; KADPCMf[^ (ۂMDRV98̏ɍ킹Ă)
;   in : DS:SI = PCMf[^̂ʒu
;        BX    = OPNAłADPCMf[^AhX(x1bit[h: 0000-FFFF)
;        AX:CX = PCMf[^̃TCY
adpcm_write:	push	ds
		cld
		add	cx,3		; TCY4bytePʂɌJグ
		adc	ax,0
		and	cx,0xfffc

		push	ax
		mov	ax,0x0001	; RESET
		call	fmout2
		mov	ax,0x1000	; Xe[^XWX^NA
		call	fmout2
		mov	ax,0x1080	; IRQ RESET
		call	fmout2
		mov	ax,0x0060	; REC/MEM DATA
		call	fmout2
		mov	ax,0x0100	; RAM, RAM TYPE x1
		call	fmout2
		inc	ah		; START ADDR(L)
		mov	al,bl
		call	fmout2
		inc	ah		; START ADDR(H)
		mov	al,bh
		call	fmout2
		mov	al,0xff
		inc	ah		; END ADDR(L)
		call	fmout2
		inc	ah		; END ADDR(H)
		call	fmout2
		mov	ah,0x0c		; LIMIT ADDR(L)
		call	fmout2
		inc	ah		; LIMIT ADDR(H)
		call	fmout2
		pop	bx		; ʃJE^BXƂ

.loop:		lodsb			; f[^ǂݍ
		mov	ah,0x08		; ADPCM DATA
		call	fmout2
		call	brdy_wait
		mov	ax,0x1080	; IRQ RESET
		call	fmout2

		cmp	si,0x8000	; ItZbg0x8000𒴂Ă琳K
		jc	.skip
		mov	dx,si
		call	adj_seg		; AhXK
		mov	si,dx

.skip:		mov	ax,bx
		or	ax,cx
		jz	.write_end	; BX=CX=0Ŕ
		sub	cx,1		; BX:CX--
		sbb	bx,0
		jmp	short .loop

.write_end:	mov	ax,0x0001	; RESET
		call	fmout2
		pop	ds
		ret

; KADPCMWX^o
;   in : AH=WX^
;        AL=f[^
fmout2:		push	ax
		push	dx
		push	cx
		mov	dx,0x018c	; FMI/O
		call	busy_wait
		xchg	al,ah
		out	dx,al		; WX^
		inc	dx
		inc	dx
;		mov	cx,0x0100	; G~Ȃ̂ŃEFCgȂĂ˓I
;.wait:		loop	.wait
		xchg	al,ah
		out	dx,al		; f[^
		out	0x5f,al		; MDRV98ł͂Ȃ̈ʒu
		pop	cx
		pop	dx
		pop	ax
		ret

busy_wait:	push	ax
.loop:		in	al,dx
		shl	al,1		; BUSY҂
		jc	.loop
		pop	ax
		ret

; BRDYtO̂҂
brdy_wait:	push	ax
		push	dx
		mov	dx,0x018c
.loop:		in	al,dx
		test	al,0x08
		jz	.loop
		pop	dx
		pop	ax
		ret

loadseg:	dw	0		; [hobt@ZOg

pcmext:		db	'.PCM',0x00	; PCMt@C̊gq
tabext:		db	'.TAB',0x00	; TABt@C̊gq

pcmname:	times 13 db 0x00	; PCMt@Cobt@(8+"."+3 + 00)
tabname:	times 13 db 0x00	; TABt@Cobt@(8+"."+3 + 00)
dsgname:	db	'        '	; CONINŎw肷PCMt@Cobt@(8)

pcm_loaded:	db	0		; PCM[hς݃tO

		align	0x10
		times 0x100 db 0xff	; X^bNGA

stack:

prgend:

